#property copyright "Joy22"

#property indicator_chart_window


//NEW CODE BEGIN
#property indicator_buffers 2

#property indicator_color1 Blue 
#property indicator_color2 Magenta
#property indicator_width1 2
#property indicator_width2 2

double CrossUp[];
double CrossDown[];

//NEW CODE END


//---- input parameters
extern int Tenkan             = 9;
extern int Kijun              = 26;
extern int Senkou             = 52;
//extern bool UseAlerts         = true;
extern bool MsgAlerts         = false;
extern bool SoundAlerts       = false;
extern bool eMailAlerts       = false;
extern bool checkChikou       = true;
extern bool checkKumo         = true;

extern bool TS_KS_Cross = true;
extern bool CS_Price_Cross = true;
extern bool Kumo_Breakout = true;

extern int delay = 0;



int a_begin;
// bool UptrendAlert1,DntrendAlert1,UptrendAlert2,DntrendAlert2,UptrendAlert3,DntrendAlert3;






int init()
  {
  
  SetIndexStyle( 0, DRAW_ARROW, EMPTY );
  SetIndexArrow( 0, 233 );
  SetIndexStyle( 1, DRAW_ARROW, EMPTY );
  SetIndexArrow( 1, 234 );
 

  SetIndexBuffer( 0, CrossUp   );
  SetIndexBuffer( 1, CrossDown );
  
  SetIndexLabel( 0, "Buy"  );
  SetIndexLabel( 1, "Sell" );
  
   return(0);
  }

int start()
{
  double Range;
  double AvgRange;
  int    iLimit;
  int    i;
  int    counter;
  int    counted_bars = IndicatorCounted();
  
  //---- check for possible errors
  if ( counted_bars < 0 ) 
    return ( -1 );
  
  //---- last counted bar will be recounted
  if ( counted_bars > 0 ) counted_bars--;

  iLimit = Bars - counted_bars;
  
for(i = 0; i <= iLimit; i++) {  

Print (i);
      counter=i;
      Range=0;
      AvgRange=0;
      for (counter=i ;counter<=i+9;counter++)
      {
         AvgRange=AvgRange+MathAbs(High[counter]-Low[counter]);
      }
      Range=AvgRange/10;
      




   double i_Tenkan = iIchimoku(NULL, 0, Tenkan, Kijun, Senkou, MODE_TENKANSEN, i+delay);
   double i_Kijun = iIchimoku(NULL, 0, Tenkan, Kijun, Senkou, MODE_KIJUNSEN, i+delay);
   double i_SenkouA = iIchimoku(NULL, 0, Tenkan, Kijun, Senkou, MODE_SENKOUSPANA, i+delay);
   double i_SenkouB = iIchimoku(NULL, 0, Tenkan, Kijun, Senkou, MODE_SENKOUSPANB, i+delay);
//   double i_Chikou = iIchimoku(NULL, 0, Tenkan, Kijun, Senkou, MODE_CHINKOUSPAN, 26);  
   
   double i_Tenkan1 = iIchimoku(NULL, 0, Tenkan, Kijun, Senkou, MODE_TENKANSEN, i+1+delay);
   double i_Kijun1 = iIchimoku(NULL, 0, Tenkan, Kijun, Senkou, MODE_KIJUNSEN, i+1+delay);
   double i_SenkouA1 = iIchimoku(NULL, 0, Tenkan, Kijun, Senkou, MODE_SENKOUSPANA, i+1+delay);
   double i_SenkouB1 = iIchimoku(NULL, 0, Tenkan, Kijun, Senkou, MODE_SENKOUSPANB, i+1+delay);
//   double i_Chikou1 = iIchimoku(NULL, 0, Tenkan, Kijun, Senkou, MODE_CHINKOUSPAN, 27);  


//----- CHECK IF CHIKOU SPAN IS ABOVE OR BELOW PRICE
   bool AboveChikou, BelowChikou;
   if (checkChikou)
   {
      if (Close[i+delay]>Close[i+delay+Kijun])
      {
         AboveChikou = true;
         BelowChikou = false;
      }
      if (Close[i+delay]<Close[i+delay+Kijun])
      {
         AboveChikou = false;
         BelowChikou = true;
      }
   }
   else
   {
      AboveChikou = true;
      BelowChikou = true;
   }  
 
//----- CHECK IF PRICE IS ABOVE OR BELOW KUMO
 
   bool AboveKumo, BelowKumo;
   if (checkKumo)
   {
      if (Close[i+delay] >= i_SenkouA && Close[i+delay] >= i_SenkouB)
      {
         AboveKumo = true;
         BelowKumo = false;
      }
      if (Close[i+delay] <= i_SenkouA && Close[i+delay] <= i_SenkouB)
      {
         AboveKumo = false;
         BelowKumo = true;
      }
       if (Close[i+delay] < i_SenkouA && Close[i+delay] > i_SenkouB)
      {
         AboveKumo = false;
         BelowKumo = false;
      }     
        if (Close[i+delay] > i_SenkouA && Close[i+delay] < i_SenkouB)
      {
         AboveKumo = false;
         BelowKumo = false;
      }       
      
      
   }
   else
   {
      AboveKumo = true;
      BelowKumo = true;
   }   
           

//--------------   TS KS Crossover BEGIN

   string Msg,Subj;
   
   if (TS_KS_Cross)
   {
      if (i_Tenkan > i_Kijun && i_Tenkan1 <= i_Kijun1 /**&& !UptrendAlert1**/ && AboveChikou && AboveKumo)
      {
         Subj = "Tenkan crosses Kijun: "+Symbol()+" on M"+Period();
         Msg = "BUY Signal --- : "+Subj+ " @ "+DoubleToStr(Close[i+delay],Digits) + ", @ " + TimeToStr(TimeLocal(),TIME_SECONDS); 
       //  UptrendAlert1 = true; 
       //  DntrendAlert1 = false;
         DoAlerts(Msg,Subj);
         CrossUp[i+delay] = Low[i+delay] - Range*0.5;
      } 
      if ( i_Tenkan < i_Kijun && i_Tenkan1 >= i_Kijun1 /**&& !DntrendAlert1**/ && BelowChikou && BelowKumo)
      {  
         Subj = "Tenkan crosses Kijun: "+Symbol()+" on M"+Period();
         Msg = "SELL Signal --- : "+Subj+ " @ "+DoubleToStr(Close[i+delay],Digits) + ", @ " + TimeToStr(TimeLocal(),TIME_SECONDS);
       //  UptrendAlert1 = false; 
       //  DntrendAlert1 = true;
         DoAlerts(Msg,Subj);
         CrossDown[i+delay] = High[i+delay] + Range*0.5;
      }
   }
 //--------------- TS KS Crossover END
 
 
 
 //-------- CHIKOU CROSSES PRICE  BEGIN
 
   if (CS_Price_Cross)
   {
      if (Close[i+delay]>Close[i+delay+Kijun] && Close[i+1+delay]<Close[i+1+delay+Kijun] /**&& !UptrendAlert2**/ && AboveChikou && AboveKumo)
      {
         Subj = "Chikou crosses Price: "+Symbol()+" on M"+Period();
         Msg = "BUY Signal --- : "+Subj+ " @ "+DoubleToStr(Close[i+1],Digits) + ", @ " + TimeToStr(TimeLocal(),TIME_SECONDS); 
   //      DntrendAlert2 = false; 
    //     UptrendAlert2 = true;
         DoAlerts(Msg,Subj);
         CrossUp[i+delay] = Low[i+delay] - Range*0.5;
      } 
      if (Close[i+delay]<Close[i+delay+Kijun] && Close[i+1+delay]>Close[i+1+delay+Kijun] /**&& !DntrendAlert2**/ && BelowChikou && BelowKumo)
      {
         Subj = "Chikou crosses Price: "+Symbol()+" on M"+Period();
         Msg = "SELL Signal --- : "+Subj+ " @ "+DoubleToStr(Close[i+delay],Digits) + ", @ " + TimeToStr(TimeLocal(),TIME_SECONDS); 
   //      DntrendAlert2 = true; 
    //     UptrendAlert2 = false;
         DoAlerts(Msg,Subj);
         CrossDown[i+delay] = High[i+delay] + Range*0.5;
      }
   }
 
 
  //-------- CHIKOU CROSSES PRICE  END
  
  
   //--------  KUMO BREAKOUT  BEGIN
   if (Kumo_Breakout)
   {
      if (((Close[i+delay]>i_SenkouA && Close[i+1+delay]<=i_SenkouA1 && i_SenkouA>i_SenkouB /**&& !UptrendAlert3**/) || (Close[i+delay]>i_SenkouB && Close[i+1+delay]<=i_SenkouB1 && i_SenkouB>i_SenkouA /**&& !UptrendAlert3**/) || (Close[i+delay]>i_SenkouA && Low[i+delay]<=i_SenkouA && i_SenkouA>i_SenkouB /**&& !UptrendAlert3**/) || (Close[i+delay]>i_SenkouB && Low[i+delay]<=i_SenkouB && i_SenkouB>i_SenkouA /**&& !UptrendAlert3**/)) && AboveChikou && AboveKumo)
      {
         Subj = "Kumo Breakout: "+Symbol()+" on M"+Period();
         Msg = "BUY Signal --- : "+Subj+ " @ "+DoubleToStr(Close[i+delay],Digits) + ", @ " + TimeToStr(TimeLocal(),TIME_SECONDS); 
      //   DntrendAlert3 = false; 
      //   UptrendAlert3 = true;
         DoAlerts(Msg,Subj);
         CrossUp[i+delay] = Low[i+delay] - Range*0.5;
      } 
      if (((Close[i+delay]<i_SenkouA && Close[i+1+delay]>=i_SenkouA1 && i_SenkouA<i_SenkouB /**&& !DntrendAlert3**/) || (Close[i+delay]<i_SenkouB && Close[i+1+delay]>=i_SenkouB1 && i_SenkouB<i_SenkouA /**&& !DntrendAlert3**/) || (Close[i+delay]<i_SenkouA && High[i+delay]>=i_SenkouA && i_SenkouA<i_SenkouB /**&& !DntrendAlert3**/) || (Close[i+delay]<i_SenkouB && High[i+delay]>=i_SenkouB && i_SenkouB<i_SenkouA /**&& !DntrendAlert3**/)) && BelowChikou && BelowKumo)
      {
         Subj = "Kumo Breakout: "+Symbol()+" on M"+Period();
         Msg = "SELL Signal --- : "+Subj+ " @ "+DoubleToStr(Close[i+delay],Digits) + ", @ " + TimeToStr(TimeLocal(),TIME_SECONDS); 
   //      DntrendAlert3 = true; 
    //     UptrendAlert3 = false;
         DoAlerts(Msg,Subj);
         CrossDown[i+delay] = High[i+delay] + Range*0.5;
      }
   }  
   
     //--------  KUMO BREAKOUT  END 
   

}
   return(0);
}
void DoAlerts(string msgText, string eMailSub)
{
   if (MsgAlerts) Alert(msgText);
   if (eMailAlerts) SendMail(eMailSub, msgText);
}
//+------------------------------------------------------------------+